<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Task72.40</title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css" />
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  <style>
    i {
      cursor: pointer;
    }
  </style>
</head>

<body>
  <div class="wrapper">
  
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search"
                  aria-label="Search" />
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->
    <!-- Main Sidebar Container -->
    <aside style="min-height: 100vh;" class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="info">
          <a href="#" class="d-block text-center">DEV CAMP</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-th"></i>
              <p>
                Manage
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="voucher.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="menu.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="drink.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="region.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Region</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="order.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order</p>
                </a>
              </li>
            </ul>
          </li>
          <!--  -->
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
  </div>
  <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Drink</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Drink</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h3 class="text-center text-primary">Quản trị Drinks</h3>
        <div class="jumbotron">
            <div class="row form-group">
                <label for="" class="col-sm-3">Mã Nước Uống</label>
                <div class="col-sm-9">
                    <input id="inp-drink-code" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Tên Nước Uống</label>
                <div class="col-sm-9">
                    <input id="inp-drink-name" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Đơn giá</label>
                <div class="col-sm-9">
                    <input id="inp-price" type="number" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Ghi chú</label>
                <div class="col-sm-9">
                    <input id="inp-note" type="text" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Ngày tạo</label>
                <div class="col-sm-9">
                    <input id="inp-create-date" type="date" class="form-control">
                </div>
            </div>

            <div class="row form-group">
                <label for="" class="col-sm-3">Ngày sửa</label>
                <div class="col-sm-9">
                    <input id="inp-update-date" type="date" class="form-control">
                </div>
            </div>
            <button id="btn-add" class="btn btn-success">Thêm mới</button>
            <button id="btn-update" class="btn btn-primary" style="display: none;">Cập nhật</button>
            <button id="btn-delete" class="btn btn-danger" style="display: none;">Xóa Drink</button>
            
        </div>
        <table id="table-drinks" class="table table-bordered table-stripped table-hover">
              <thead>
                  <tr>
                      <th>STT</th>
                      <th>Mã Nước Uống</th>
                      <th>Tên Nước Uống</th>
                      <th>Đơn Giá</th>
                      <th>Ghi Chú</th>
                      <th>Ngày Tạo</th>
                      <th>Ngày Cập Nhật</th>
  
                  </tr>
              </thead>
              <tbody></tbody>
          </table>
        
      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
    <!-- /.content-wrapper -->
  </div>
  </div>
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.1.0
    </div>
  </footer>
  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- jQuery UI 1.11.4 -->
  <script src="plugins/jquery-ui/jquery-ui.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- DataTables  & Plugins -->
  <script src="plugins/datatables/jquery.dataTables.min.js"></script>
  <script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
    var gTableDrinks = $("#table-drinks").DataTable({
        columns: [
            { data: "id"},
            { data: "maNuocUong"},
            { data: "tenNuocUong"},
            { data: "donGia"},
            { data: "ghiChu"},
            { data: "ngayTao"},
            { data: "ngayCapNhat"}
        ],
        columnDefs: [
            {
                targets: 0,
                render: function() {
                    return gStt++;
                }
            }
        ]
    });
  
    var gStt = 1;
    var gDrinkId = null;
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
  
    // Thực thi sự kiện nhấn vào row trong datatable
    $("#table-drinks").on("click", "tr", function() {
        onClickRow(this);
    });
  
    // Thực thi sự kiện nhấn nút tạo mới drink 
    $("#btn-add").on("click", function(){
        onBtnAddNewClick();
    });
  
    // Thực thi sự kiện nhấn nút cập nhật drink 
    $("#btn-update").on("click", function(){
        onBtnUpdateClick();
    });
  
    // Thực thi sự kiện nhấn nút xóa voucher 
    $("#btn-delete").on("click", function(){
        $("#modal-delete").modal("show");
    });
  
    // Thực thi sự kiện xác nhận xóa trong modal delete
    $("#btn-confirm").on("click", function() {
        onBtnDeleteClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        callApiToLoadListDrinks();
    }
  
    // Hàm sự kiện nhấn vào row drink
    function onClickRow(paramRow) {
        var vDataRow = gTableDrinks.row(paramRow).data();
        $("#inp-drink-code").val(vDataRow.maNuocUong);
        $("#inp-drink-name").val(vDataRow.tenNuocUong);
        $("#inp-note").val(vDataRow.ghiChu);
        $("#inp-price").val(vDataRow.donGia);
        $("#inp-create-date").val(formatDate(vDataRow.ngayTao));
        if(vDataRow.ngayCapNhat != null) {
            $("#inp-update-date").val(formatDate(vDataRow.ngayCapNhat));
        }
        else {
            $("#inp-update-date").val(vDataRow.ngayCapNhat);
        }
  
        $("#btn-add").hide();
        $("#btn-update").show();
        $("#btn-delete").show();
        gDrinkId = vDataRow.id;
    }
  
  
    // Hàm xử lý sự kiện nhấn nút thêm mới drink
    function onBtnAddNewClick() {
        var vDrink = {
            maNuocUong: "",
            tenNuocUong: "",
            donGia: "",
            ghiChu: ""
        }
  
        getData(vDrink);
        console.log(vDrink)
        var vValidate = validateData(vDrink);
        if(vValidate) {
            callApiToCreateNew(vDrink);
        }
    }
  
    // Hàm xử lý sự kiện nhấn nút sửa 1 drinks
    function onBtnUpdateClick() {
        var vDrink = {
            maNuocUong: "",
            tenNuocUong: "",
            donGia: "",
            ghiChu: ""
        }
  
        getData(vDrink);
        console.log(vDrink)
        var vValidate = validateData(vDrink);
        if(vValidate) {
            callApiToUpdate(vDrink);
        }
    }
  
    // Hàm nhấn nút delete drink
    function onBtnDeleteClick() {
        $.ajax({
            type: "DELETE",
            url: "http://localhost:8080/drinks/" + gDrinkId,
            success: function(paramRes) {
                alert("Drink đã bị xóa!");
                callApiToLoadListDrinks();
                resetForm();
                $("#modal-delete").modal("hide");
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Xóa drink thất bại, vui lòng thử lại!");
                $("#modal-delete").modal("hide");
            }
        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  
    // Hàm gọi APi để load dữ liệu Drink vào table
    function callApiToLoadListDrinks() {
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/drinks",
            success: function(paramRes) {
                console.log(paramRes);
                loadDataToTable(paramRes);
            },
            error: function(paramError) {
                console.log(paramError.status);
            }
        })
    }
  
    // Hàm load dữ liệu vào table
    function loadDataToTable(paramVoucherData) {
        gStt = 1;
        gTableDrinks.clear();
        gTableDrinks.rows.add(paramVoucherData);
        gTableDrinks.draw();
    }
  
    // Hàm format lại ngày tháng
    function formatDate(paramDate) {
        var vDate = paramDate.split("-");
        return vDate[2]+ "-" + vDate[1] + "-" + vDate[0];
    }
  
    // Hàm lấy dữ liệu voucher từ form
    function getData(paramVoucherData) {
        paramVoucherData.maNuocUong = $("#inp-drink-code").val();
        paramVoucherData.tenNuocUong = $("#inp-drink-name").val();
        paramVoucherData.donGia = $("#inp-price").val();
        paramVoucherData.ghiChu = $("#inp-note").val();
    }
  
    // Hàm validate dữ liệu
    function validateData(paramData) {
        if(paramData.maNuocUong == "") {
            alert("Vui lòng nhập mã nước uống!");
            return false;
        }
        if(paramData.tenNuocUong == "") {
            alert("Vui lòng nhập tên nước uống");
            return false;
        }
        if(paramData.donGia == "") {
            alert("Vui lòng nhập giá tiền");
            return false;
        }
        if(paramData.donGia < 5000 || paramData.phanTramGiamGia >= 1000000 ) {
            alert("Giá tiền chưa phù hợp!");
            return false;
        }
  
        return true;
    }
  
    // Hàm gọi api để thêm mới drink  
    function callApiToCreateNew(paramData) {
        $.ajax({
            type: "POST",
            url: "http://localhost:8080/drinks",
            contentType: "application/json",
            data: JSON.stringify(paramData),
            success: function(paramRes) {
                alert("Tạo mới thành công!");
                resetForm();
                callApiToLoadListDrinks();
            }, 
            error: function(paramError) {
                console.log(paramError.status);
            }
        });
    }
  
    // Hàm reset form 
    function resetForm() {
        $("#inp-drink-code").val("");
        $("#inp-drink-name").val("");
        $("#inp-price").val("");
        $("#inp-note").val("");
        $("#inp-create-date").val("");
        $("#inp-update-date").val("");
  
  
        $("#btn-add").show();
        $("#btn-update").hide();
        $("#btn-delete").hide();
    }
  
    // Hàm gọi API để sửa 1 drink
    function callApiToUpdate(paramData) {
        $.ajax({
            type: "PUT",
            url: "http://localhost:8080/drinks/" + gDrinkId,
            contentType: "application/json",
            data: JSON.stringify(paramData),
            success: function(paramRes) {
                alert("Cập nhật thành công!");
                resetForm();
                callApiToLoadListDrinks();
            }, 
            error: function(paramError) {
                console.log(paramError.status);
            }
        });
    }
  
  
  </script>
</body>

</html>